﻿using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Web;
using System.Web.Http;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WebApi;

namespace HelloWorld.Controllers
{
    [RoutePrefix("HelloWorld")]
    public class HelloWorldController : ApiController
    {
        //[Route("tile/{z}/{x}/{y}")]
        //[HttpGet]
        //public HttpResponseMessage GetTile(int z, int x, int y)
        //{
        //    // Create a new Layer and pass the path to a Shapefile into its constructor.
        //    ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath(@"~/App_Data/cntry02.shp"));
        //    Proj4Projection proj4 = new Proj4Projection();
        //    proj4.InternalProjectionParametersString = Proj4Projection.GetWgs84ParametersString();
        //    proj4.ExternalProjectionParametersString = Proj4Projection.GetSphericalMercatorParametersString();
        //    proj4.Open();

        //    worldLayer.FeatureSource.Projection = proj4;

        //    // Set the worldLayer to use a preset Style. Since AreaStyles.Country1 has a YellowGreen background and Black border, our worldLayer will have the same render style. 
        //    AreaStyle areaStyle = new AreaStyle();
        //    areaStyle.FillSolidBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 233, 232, 214));
        //    areaStyle.OutlinePen = new GeoPen(GeoColor.FromArgb(255, 118, 138, 69), 1);
        //    areaStyle.OutlinePen.DashStyle = LineDashStyle.Solid;
        //    worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = areaStyle;

        //    // This setting will apply from ZoomLevel01 to ZoomLevel20, which means the map will be rendered in the same style, no matter how far we zoom in or out. 
        //    worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

        //    // Capital layer
        //    ShapeFileFeatureLayer capitalLayer = new ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath("~/App_Data/capital.shp"));
        //    capitalLayer.FeatureSource.Projection = proj4;
        //    // We can customize our own Style. Here we pass in a color and a size.
        //    capitalLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColor.StandardColors.White, 7, GeoColor.StandardColors.Brown);
        //    // The Style we set here is applied from ZoomLevel01 to ZoomLevel05. That means if we zoom in a bit more, this particular style will no longer be visible.
        //    capitalLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level05;
        //    PointStyle pointStyle = new PointStyle();
        //    pointStyle.SymbolType = PointSymbolType.Square;
        //    pointStyle.SymbolSolidBrush = new GeoSolidBrush(GeoColor.StandardColors.White);
        //    pointStyle.SymbolPen = new GeoPen(GeoColor.StandardColors.Black, 1);
        //    pointStyle.SymbolSize = 6;

        //    PointStyle stackStyle = new PointStyle();
        //    stackStyle.SymbolType = PointSymbolType.Square;
        //    stackStyle.SymbolSolidBrush = new GeoSolidBrush(GeoColor.StandardColors.Maroon);
        //    stackStyle.SymbolPen = new GeoPen(GeoColor.StandardColors.Transparent, 0);
        //    stackStyle.SymbolSize = 2;

        //    pointStyle.CustomPointStyles.Add(stackStyle);


        //    capitalLayer.ZoomLevelSet.ZoomLevel06.DefaultPointStyle = pointStyle;
        //    // The Style we set here is applied from ZoomLevel06 to ZoomLevel20. That means if we zoom out a bit more, this particular style will no longer be visible.
        //    capitalLayer.ZoomLevelSet.ZoomLevel06.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

        //    // Label layer
        //    ShapeFileFeatureLayer capitalLabelLayer = new ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath("~/App_Data/capital.shp"));
        //    capitalLabelLayer.FeatureSource.Projection = proj4;
        //    // We can customize our own TextStyle. Here we pass in the font, the size, the style and the color.
        //    capitalLabelLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("CITY_NAME", "Arial", 8, DrawingFontStyles.Italic, GeoColor.StandardColors.Black, 3, 3);
        //    // The TextStyle we set here is applied from ZoomLevel01 to ZoomLevel05. 
        //    capitalLabelLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level05;

        //    GeoFont font = new GeoFont("Arial", 9, DrawingFontStyles.Bold);
        //    GeoSolidBrush txtBrush = new GeoSolidBrush(GeoColor.StandardColors.Maroon);
        //    TextStyle textStyle = new TextStyle("CITY_NAME", font, txtBrush);
        //    textStyle.XOffsetInPixel = 0;
        //    textStyle.YOffsetInPixel = -6;
        //    capitalLabelLayer.ZoomLevelSet.ZoomLevel06.DefaultTextStyle = textStyle;
        //    // The TextStyle we set here is applied from ZoomLevel06 to ZoomLevel20.
        //    capitalLabelLayer.ZoomLevelSet.ZoomLevel06.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
        //    // Change the number below (to 0, for example) to better understand how this works.

        //    LayerOverlay layerOverlay = new LayerOverlay();
        //    layerOverlay.Layers.Add(worldLayer);
        //    layerOverlay.Layers.Add(capitalLayer);
        //    layerOverlay.Layers.Add(capitalLabelLayer);

        //    using (Bitmap bitmap = new Bitmap(256, 256))
        //    {
        //        PlatformGeoCanvas geoCanvas = new PlatformGeoCanvas();
        //        RectangleShape boundingBox = WebApiExtentHelper.GetBoundingBoxForXyz(x, y, z, GeographyUnit.Meter);
        //        geoCanvas.BeginDrawing(bitmap, boundingBox, GeographyUnit.Meter);
        //        layerOverlay.Draw(geoCanvas);
        //        geoCanvas.EndDrawing();

        //        MemoryStream ms = new MemoryStream();
        //        bitmap.Save(ms, ImageFormat.Png);

        //        HttpResponseMessage msg = new HttpResponseMessage(HttpStatusCode.OK);
        //        msg.Content = new ByteArrayContent(ms.ToArray());
        //        msg.Content.Headers.ContentType = new MediaTypeHeaderValue("image/png");

        //        return msg;
        //    }
        //}

        [Route("tile/{layerId}/{z}/{x}/{y}")]
        [HttpGet]
        public HttpResponseMessage GetTile(string layerId, int z, int x, int y)
        {
            Proj4Projection proj4 = new Proj4Projection();
            proj4.InternalProjectionParametersString = Proj4Projection.GetWgs84ParametersString();
            proj4.ExternalProjectionParametersString = Proj4Projection.GetSphericalMercatorParametersString();
            proj4.Open();

            LayerOverlay layerOverlay = new LayerOverlay();

            if (layerId.ToLowerInvariant() == "usstates")
            {
                // States layer
                ShapeFileFeatureLayer statesLayer = new ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath("~/App_Data/USStates.shp"));
                statesLayer.FeatureSource.Projection = proj4;
                AreaStyle areaStyle = new AreaStyle();
                areaStyle.FillSolidBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 233, 232, 214));
                areaStyle.OutlinePen = new GeoPen(GeoColor.FromArgb(255, 118, 138, 69), 1);
                areaStyle.OutlinePen.DashStyle = LineDashStyle.Solid;

                statesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = areaStyle;
                statesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                layerOverlay.Layers.Add(statesLayer);
            }
            else if (layerId.ToLowerInvariant() == "uscities")
            {
                // Cities layer
                ShapeFileFeatureLayer countyLayer = new ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath("~/App_Data/cities_a.shp"));
                countyLayer.FeatureSource.Projection = proj4;
                PointStyle pointStyle = new PointStyle();
                pointStyle.SymbolType = PointSymbolType.Square;
                pointStyle.SymbolSolidBrush = new GeoSolidBrush(GeoColor.StandardColors.White);
                pointStyle.SymbolPen = new GeoPen(GeoColor.StandardColors.Black, 1);
                pointStyle.SymbolSize = 6;

                PointStyle stackStyle = new PointStyle();
                stackStyle.SymbolType = PointSymbolType.Square;
                stackStyle.SymbolSolidBrush = new GeoSolidBrush(GeoColor.StandardColors.Maroon);
                stackStyle.SymbolPen = new GeoPen(GeoColor.StandardColors.Transparent, 0);
                stackStyle.SymbolSize = 2;

                pointStyle.CustomPointStyles.Add(stackStyle);
                countyLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = pointStyle;
                GeoFont font = new GeoFont("Arial", 9, DrawingFontStyles.Bold);
                GeoSolidBrush txtBrush = new GeoSolidBrush(GeoColor.StandardColors.Maroon);
                TextStyle textStyle = new TextStyle("AREANAME", font, txtBrush);
                textStyle.XOffsetInPixel = 0;
                textStyle.YOffsetInPixel = -6;
                countyLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = textStyle;
                countyLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                layerOverlay.Layers.Add(countyLayer);
            }

            using (Bitmap bitmap = new Bitmap(256, 256))
            {
                PlatformGeoCanvas geoCanvas = new PlatformGeoCanvas();
                RectangleShape boundingBox = WebApiExtentHelper.GetBoundingBoxForXyz(x, y, z, GeographyUnit.Meter);
                geoCanvas.BeginDrawing(bitmap, boundingBox, GeographyUnit.Meter);
                layerOverlay.Draw(geoCanvas);
                geoCanvas.EndDrawing();

                MemoryStream ms = new MemoryStream();
                bitmap.Save(ms, ImageFormat.Png);

                HttpResponseMessage msg = new HttpResponseMessage(HttpStatusCode.OK);
                msg.Content = new ByteArrayContent(ms.ToArray());
                msg.Content.Headers.ContentType = new MediaTypeHeaderValue("image/png");

                return msg;
            }
        }
    }
}